#pragma once

#pragma once

#include "CoreMinimal.h"
#include "CityMap.h"
#include <vector>
#include <unordered_map>


enum WalkStatus {
	walking,
	finished
};

/**
 *
 */
class CROWDSIMULATION_API Walk
{
public:
	Walk();
	Walk(const FVector start, const FVector end, const CityMap* map, const float tolerance);
	Walk(const FVector start, const FVector end, const float tolerance);
	~Walk();

	int getForce(const FVector agent_loc, FVector& force);
	bool endReached();

protected:

	void bfs(std::unordered_map<const Tiles*, const Tiles*>& pred,
		const Tiles* start_tile, const Tiles* end_tile);

	std::vector<FVector> checkpoints;
	float tolerance2;

};
